// Set 13 -- Using Data in the Array
// Version G
// Draw gold bars



// Closing gold prices on one day between Feb 23 and 28 
// from 1975 go 2011
// Source  Kitco.com
int [ ] gold = {  185, 133, 139, 180, 250, 616, 500, 366, 464, 395, 
                  284, 352, 405, 432, 488, 415, 358, 350, 329, 376, 
                  377, 398, 353, 292, 286, 294, 260, 292, 257, 400, 
                  434, 564, 683, 937, 978, 1094, 1401 };
PFont f;

final int FIRST_YEAR = 1975;
final int LAST_YEAR = 2011;

float leftEdge, rightEdge, topEdge, bottomEdge;

int minValue, maxValue;


void setup( )
{
  size( 1000, 600 );
  f = loadFont( "f.vlw" );
  textFont( f );
  textSize( 12 );
  textAlign(CENTER, CENTER);
  // new code
  rectMode( CORNERS );
  // end new code
  
  leftEdge = 10;
  rightEdge = width-10;
  topEdge = 20;
  bottomEdge = height-20;

  minValue = min(gold);
  maxValue = max(gold);
  
}

void draw( )
{
    //println( gold.length );
   testPlots( );
   
   noLoop( ); 
}

// New code
float computeMean( )
{
   float sum = 0;
   for(int i = 0; i < gold.length; i++)
  {
     sum += gold[i];
  } 
  float mean = sum/gold.length;
  return mean;
}

void testPlots( )
{
  fill( 0 );
  float oldX, oldY;
  oldX = 0;
  oldY = 0;
  
  for ( int i = 0; i < gold.length; i++)
  {
     float x = map( i, 0, gold.length, leftEdge, rightEdge);
     float y = map( gold[i], maxValue, minValue, topEdge, bottomEdge);
    
     stroke( 0, 0, 255 );
     strokeWeight( 4 );
     point( x, y );

     fill( 0 );
     int year = (i + FIRST_YEAR)%100;
     if ( year < 10 )
     {
       text( "0" + year, x, y-10 );
     }
     else
     {
       text( year, x, y-10 );
     }

     if ( i > 0 )
     {
        if (y < oldY)
        {
          stroke( 0, 200, 0 );
        }
        else
        {
           stroke( 255, 0, 0 );
        } 
        strokeWeight( 1 );
        line( oldX, oldY, x, y );        
     }
     
     // new code
     // draw the gold bars
     fill( 200, 200, 0 );
     stroke(0);
     strokeWeight( 1 );
     rect( x-5, y, x+5, bottomEdge );
     // end of new code
     
     oldX = x;
     oldY = y;
  } 
}



