// Set 13 -- Using Data in the Array
// Version I
// Plot Mean Value



// Closing gold prices on one day between Feb 23 and 28 
// from 1975 go 2011
// Source  Kitco.com
int [ ] gold = {  185, 133, 139, 180, 250, 616, 500, 366, 464, 395, 
                  284, 352, 405, 432, 488, 415, 358, 350, 329, 376, 
                  377, 398, 353, 292, 286, 294, 260, 292, 257, 400, 
                  434, 564, 683, 937, 978, 1094, 1401 };
PFont f;

final int FIRST_YEAR = 1975;
final int LAST_YEAR = 2011;

float leftEdge, rightEdge, topEdge, bottomEdge;

int minValue, maxValue;
float mean, median;

void setup( )
{
  size( 1000, 600 );
  f = loadFont( "f.vlw" );
  textFont( f );
  textSize( 12 );
  textAlign(CENTER, CENTER);
  rectMode( CORNERS );
  
  leftEdge = 10;
  rightEdge = width-10;
  topEdge = 20;
  bottomEdge = height-20;

  minValue = min(gold);
  maxValue = max(gold);
  
  mean = computeMean( );
}

void draw( )
{
   testPlots( ); 
   // new code
   plotMean( );
   // end new code 
   noLoop( ); 
}

// New code
void plotMean ( )
{
   float y = map( mean, maxValue, minValue, topEdge, bottomEdge); 
   stroke( 0, 0, 255 );
   strokeWeight( 2 );
   line( leftEdge, y, rightEdge, y );  
   fill( 0, 0, 255 );
   text( "Mean", leftEdge+20, y-10 );
}

float computeMean( )
{
   float sum = 0;
   for(int i = 0; i < gold.length; i++)
  {
     sum += gold[i];
  } 
  float mean = sum/gold.length;
  return mean;
}

void testPlots( )
{

  fill( 0 );
  float oldX, oldY;
  oldX = 0;
  oldY = 0;
  
  for ( int i = 0; i < gold.length; i++)
  {
     // compute x, y values for current gold value
     float x = map( i, 0, gold.length, leftEdge, rightEdge);
     //float y = map( gold[i], minValue, maxValue, topEdge, bottomEdge);
     float y = map( gold[i], maxValue, minValue, topEdge, bottomEdge);
    
     // draw a point for each value
     stroke( 0, 0, 255 );
     strokeWeight( 4 );
     point( x, y );
     // label the points:
       // add a leading zero for years 2000 to 2009
     fill( 0 );
     int year = (i + FIRST_YEAR)%100;
     if ( year < 10 )
     {
       text( "0" + year, x, y-10 );
     }
     else
     {
       text( year, x, y-10 );
     }
     // for years after 1975, compare current price to last year's price
     // and color line green for gains and red for losses
     if ( i > 0 )
     {
        if (y < oldY)
        {
          stroke( 0, 200, 0 );
        }
        else
        {
           stroke( 255, 0, 0 );
        } 
        strokeWeight( 1 );
        line( oldX, oldY, x, y );
        
     }
     
     // draw the gold bars
     fill( 200, 200, 0 );
     stroke(0);
     strokeWeight( 1 );
     rect( x-5, y, x+5, bottomEdge );
     
     // save current value of x and y for use in the next iteration
     oldX = x;
     oldY = y;
  }
  
}



